Index: anonymous.cs
===================================================================
--- anonymous.cs	(revision 63019)
+++ anonymous.cs	(working copy)
@@ -419,135 +837,329 @@
 			//MethodBuilder builder = method_data.MethodBuilder;
 			//ILGenerator ig = builder.GetILGenerator ();
 
-			aec = new EmitContext (ec.ResolveContext,
-				ec.TypeContainer, ec.DeclContainer, loc, null,
-				invoke_mb.ReturnType,
-				/* REVIEW */ (ec.InIterator ? Modifiers.METHOD_YIELDS : 0) |
-				(ec.InUnsafe ? Modifiers.UNSAFE : 0) |
-				(ec.IsStatic ? Modifiers.STATIC : 0),
-				/* No constructor */ false);
+			Report.Debug (64, "COMPATIBLE", this, Parent, GenericMethod, Host,
+				      Container, Block, invoke_mb.ReturnType, delegate_type,
+				      delegate_type.IsGenericType, loc);
 
-			aec.CurrentAnonymousMethod = this;
-			ContainerAnonymousMethod = ec.CurrentAnonymousMethod;
-			ContainingBlock = ec.CurrentBlock;
+			anonymous = new AnonymousMethod (
+				Parent != null ? Parent.AnonymousMethod : null, Host,
+				GenericMethod, parameters, Container, Block, invoke_mb.ReturnType,
+				delegate_type, loc);
 
-			if (aec.ResolveTopBlock (ec, Block, Parameters, null, out unreachable)){
-				anonymous_delegate = new AnonymousDelegate (
-					this, delegate_type, loc).Resolve (ec);
-				return anonymous_delegate;
-			}
-			return null;
+			if (!anonymous.Resolve (ec))
+				return null;
+
+			return anonymous.AnonymousDelegate;
 		}
 
 		public override Expression DoResolve (EmitContext ec)
 		{
-			if (!ec.IsAnonymousMethodAllowed) {
-				Report.Error (1706, loc, "Anonymous methods are not allowed in the attribute declaration");
-				return null;
-			}
+			//
+			// Set class type, set type
+			//
 
-			if (Parameters != null && !Parameters.Resolve (ec)) {
+			eclass = ExprClass.Value;
+
+			//
+			// This hack means `The type is not accessible
+			// anywhere', we depend on special conversion
+			// rules.
+			// 
+			type = TypeManager.anonymous_method_type;
+
+			if ((Parameters != null) && !Parameters.Resolve (ec))
 				return null;
-			}
 
-			return base.DoResolve (ec);
+			return this;
 		}
 
+		public override void Emit (EmitContext ec)
+		{
+			// nothing, as we only exist to not do anything.
+		}
 
-		public override string ExprClassName {
-			get {
-				return "anonymous method";
-			}
+		public bool IsIterator {
+			get { return false; }
 		}
+	}
 
-		public MethodInfo GetMethodBuilder ()
+	public abstract class AnonymousContainer : IAnonymousContainer
+	{
+		// Used to generate unique method names.
+		protected static int anonymous_method_count;
+
+		public readonly Location Location;
+
+		// An array list of AnonymousMethodParameter or null
+		public readonly Parameters Parameters;
+
+		//
+		// The block that makes up the body for the anonymous mehtod
+		//
+		public readonly ToplevelBlock Block;
+
+		public readonly Type ReturnType;
+		public readonly TypeContainer Host;
+
+		//
+		// The implicit method we create
+		//
+		protected Method method;
+		protected EmitContext aec;
+
+		// The emit context for the anonymous method
+		protected bool unreachable;
+		protected readonly Location loc;
+		protected readonly ToplevelBlock container;
+		protected readonly GenericMethod generic;
+		protected readonly AnonymousMethodHost root_scope;
+
+		//
+		// Points to our container anonymous method if its present
+		//
+		public readonly AnonymousContainer ContainerAnonymousMethod;
+
+		protected AnonymousContainer (AnonymousContainer parent, TypeContainer host,
+					      GenericMethod generic, Parameters parameters,
+					      ToplevelBlock container, ToplevelBlock block,
+					      Type return_type, int mod, Location loc)
 		{
-			MethodInfo builder = method.MethodBuilder;
-			if (TypeArguments != null)
-				return builder.MakeGenericMethod (TypeArguments);
-			else
-				return builder;
+			this.ContainerAnonymousMethod = parent;
+			this.ReturnType = return_type;
+			this.Host = host;
+
+			this.container = container;
+			this.generic = parent != null ? null : generic;
+			this.root_scope = container.AnonymousMethodHost;
+			this.Parameters = parameters;
+			this.Block = block;
+			this.loc = loc;
 		}
 
-		public override string GetSignatureForError ()
+#if FIXME
+		protected AnonymousContainer (TypeContainer host, GenericMethod generic,
+					      Parameters parameters, ToplevelBlock container,
+					      int mod, Location loc)
+			: this (null, generic, host, parameters, container, null, mod, loc)
 		{
-			string s = TypeManager.CSharpSignature (invoke_mb);
-			return s.Substring (0, s.IndexOf (".Invoke("));
+			Block = new ToplevelBlock (container, parameters, loc);
+			Block.SetHaveAnonymousMethods (loc, this);
 		}
-		
-		public bool EmitMethod (EmitContext ec)
+#endif
+
+		public Method Method {
+			get { return method; }
+		}
+
+		public virtual AnonymousMethodHost RootScope {
+			get { return root_scope; }
+		}
+
+		public ScopeInfo Scope {
+			get { return ContainerCaptureContext.Scope; }
+		}
+
+		public string GetSignatureForError ()
 		{
-			if (!CreateMethodHost (ec))
+			return RootScope.GetSignatureForError ();
+		}
+
+		protected virtual CaptureContext ContainerCaptureContext {
+			get { return Container.CaptureContext; }
+		}
+
+		protected virtual CaptureContext CaptureContext {
+			get { return Block.CaptureContext; }
+		}
+
+		public virtual bool Resolve (EmitContext ec)
+		{
+			if (!ec.IsAnonymousMethodAllowed) {
+				Report.Error (1706, loc,
+					      "Anonymous methods are not allowed in the " +
+					      "attribute declaration");
 				return false;
+			}
 
-			MethodBuilder builder = method.MethodBuilder;
-			ILGenerator ig = builder.GetILGenerator ();
-			aec.ig = ig;
+			Report.Debug (64, "RESOLVE ANONYMOUS METHOD", this, loc, ec,
+				      RootScope, Parameters, ec.IsStatic);
 
-			Parameters.ApplyAttributes (builder);
+			aec = new EmitContext (
+				ec.ResolveContext, ec.TypeContainer, RootScope, loc, null, ReturnType,
+				/* REVIEW */ (ec.InIterator ? Modifiers.METHOD_YIELDS : 0) |
+				(ec.InUnsafe ? Modifiers.UNSAFE : 0), /* No constructor */ false);
 
-			//
-			// Adjust based on the computed state of the
-			// method from CreateMethodHost
-			
-			aec.MethodIsStatic = (method_modifiers & Modifiers.STATIC) != 0;
-			
-			aec.EmitMeta (Block);
-			aec.EmitResolvedTopBlock (Block, unreachable);
+			aec.capture_context = CaptureContext;
+			aec.CurrentAnonymousMethod = this;
+
+			Report.Debug (64, "RESOLVE ANONYMOUS METHOD #1", this, loc, ec, aec,
+				      RootScope, Parameters, Block, Block.CaptureContext);
+
+			bool unreachable;
+			if (!aec.ResolveTopBlock (ec, Block, Parameters, null, out unreachable))
+				return false;
+
+			Report.Debug (64, "RESOLVE ANONYMOUS METHOD #3", this, ec, aec, Block,
+				      ec.capture_context);
+
+			ContainerCaptureContext.ComputeMethodHost ();
+
+			Report.Debug (64, "RESOLVE ANONYMOUS METHOD #4", this, Scope);
+
+			if (Scope == null)
+				throw new InternalErrorException ();
+
+			method = DoCreateMethodHost (ec);
+
 			return true;
 		}
 
-		public override void CreateScopeType (EmitContext ec, ScopeInfo scope)
+		protected abstract Method DoCreateMethodHost (EmitContext ec);
+
+		public ToplevelBlock Container {
+			get { return container; }
+		}
+
+		public GenericMethod GenericMethod {
+			get { return generic; }
+		}
+
+		public abstract bool IsIterator {
+			get;
+		}
+
+#if FIXME
+		public override string ToString ()
 		{
-			TypeBuilder container = ec.TypeContainer.TypeBuilder;
-			string name = String.Format ("<>AnonHelp<{0}>", scope.id);
+			return String.Format ("{0} ({1})", GetType (), Name);
+		}
+#endif
 
-			scope.ScopeTypeBuilder = container.DefineNestedType (name,
-				TypeAttributes.Sealed | TypeAttributes.BeforeFieldInit | TypeAttributes.NestedPrivate,
-					 TypeManager.object_type);
+		protected class AnonymousMethodMethod : Method
+		{
+			public AnonymousContainer AnonymousMethod;
 
-			Type [] constructor_types = Type.EmptyTypes;
-			ConstructorBuilder ctor = scope.ScopeTypeBuilder.DefineConstructor (
-				MethodAttributes.Public | MethodAttributes.HideBySig |
-				MethodAttributes.SpecialName | MethodAttributes.RTSpecialName,
-				CallingConventions.HasThis, constructor_types);
-			TypeManager.RegisterMethod (ctor, Parameters.EmptyReadOnlyParameters);
+			public AnonymousMethodMethod (AnonymousContainer am, GenericMethod generic,
+						      TypeExpr return_type, int mod, MemberName name,
+						      Parameters parameters)
+				: base (am.RootScope, generic, return_type, mod, false,
+					name, parameters, null)
+			{
+				this.AnonymousMethod = am;
 
-			ILGenerator cig = ctor.GetILGenerator ();
-			cig.Emit (OpCodes.Ldarg_0);
-			cig.Emit (OpCodes.Call, TypeManager.object_ctor);
-			cig.Emit (OpCodes.Ret);
+				am.RootScope.CheckMembersDefined ();
+				am.Scope.AddMethod (this);
+				Block = am.Block;
+			}
 
-			if (ec.TypeContainer.IsGeneric) {
-				TypeParameter[] tparam = ec.TypeContainer.TypeParameters;
-				string[] names = new string [tparam.Length];
-				Type[] types = new Type [tparam.Length];
+			public override EmitContext CreateEmitContext (DeclSpace tc, ILGenerator ig)
+			{
+				EmitContext aec = AnonymousMethod.aec;
+				aec.ig = ig;
+				return aec;
+			}
+		}
+	}
 
-				for (int i = 0; i < names.Length; i++) {
-					names [i] = tparam [i].Name;
-					types [i] = tparam [i].Type;
-				}
+	public class AnonymousMethod : AnonymousContainer
+	{
+		public readonly Type DelegateType;
 
-				scope.ScopeTypeBuilder.DefineGenericParameters (names);
-				scope.ScopeTypeBuilder.GetGenericTypeDefinition ();
+		//
+		// The value return by the Compatible call, this ensure that
+		// the code works even if invoked more than once (Resolve called
+		// more than once, due to the way Convert.ImplicitConversion works
+		//
+		Expression anonymous_delegate;
 
-				scope.ScopeType = scope.ScopeTypeBuilder.MakeGenericType (types);
+		public AnonymousMethod (AnonymousMethod parent, TypeContainer host,
+					GenericMethod generic, Parameters parameters,
+					ToplevelBlock container, ToplevelBlock block,
+					Type return_type, Type delegate_type, Location loc)
+			: base (parent, host, generic, parameters, container, block,
+				return_type, 0, loc)
+		{
+			this.DelegateType = delegate_type;
+
+			// Container.CaptureContext.RegisterScope (RootScope);
+		}
+
+		public override bool IsIterator {
+			get { return false; }
+		}
+
+		public Expression AnonymousDelegate {
+			get { return anonymous_delegate; }
+		}
+
+		//
+		// Creates the host for the anonymous method
+		//
+		protected override Method DoCreateMethodHost (EmitContext ec)
+		{
+			string name = "<>c__AnonymousMethod" + anonymous_method_count++;
+			MemberName member_name;
+
+			GenericMethod generic_method = null;
+			if (DelegateType.IsGenericType) {
+				TypeArguments args = new TypeArguments (loc);
+
+				Type[] tparam = TypeManager.GetTypeArguments (DelegateType);
+				for (int i = 0; i < tparam.Length; i++)
+					args.Add (new SimpleName (tparam [i].Name, loc));
+
+				member_name = new MemberName (name, args, loc);
+
+				generic_method = new GenericMethod (
+					Scope.NamespaceEntry, Scope, member_name,
+					new TypeExpression (ReturnType, loc), Parameters);
+
+				generic_method.SetParameterInfo (null);
 			} else
-				scope.ScopeType = scope.ScopeTypeBuilder;
+				member_name = new MemberName (name, loc);
 
+			return new AnonymousMethodMethod (
+				this, generic_method, new TypeExpression (ReturnType, loc),
+				Modifiers.INTERNAL, member_name, Parameters);
+		}
 
-			if (ec.TypeContainer.IsGeneric)
-				scope.ScopeConstructor = TypeBuilder.GetConstructor (
-					scope.ScopeType, ctor);
-			else
-				scope.ScopeConstructor = ctor;
+		public override bool Resolve (EmitContext ec)
+		{
+			if (!base.Resolve (ec))
+				return false;
+
+			anonymous_delegate = new AnonymousDelegate (this, DelegateType, loc).Resolve (ec);
+			if (anonymous_delegate == null)
+				return false;
+
+			return true;
 		}
 
+		public MethodInfo GetMethodBuilder (EmitContext ec)
+		{
+			MethodInfo builder = method.MethodBuilder;
+			if (RootScope.IsGeneric) {
+				MethodGroupExpr mg = (MethodGroupExpr) Expression.MemberLookup (
+					ec.ContainerType, RootScope.ScopeType, builder.Name, loc);
+
+				if (mg == null)
+					throw new InternalErrorException ();
+				builder = (MethodInfo) mg.Methods [0];
+			}
+
+			if (!DelegateType.IsGenericType)
+				return builder;
+
+			Type[] targs = TypeManager.GetTypeArguments (DelegateType);
+			return builder.MakeGenericMethod (targs);
+		}
+
 		public static void Error_AddressOfCapturedVar (string name, Location loc)
 		{
 			Report.Error (1686, loc,
-				"Local variable `{0}' or its members cannot have their address taken and be used inside an anonymous method block",
-				name);
+				      "Local variable `{0}' or its members cannot have their " +
+				      "address taken and be used inside an anonymous method block",
+				      name);
 		}
 	}
 
@@ -573,69 +1185,41 @@
 		
 		public override void Emit (EmitContext ec)
 		{
-			if (!am.EmitMethod (ec))
-				return;
+			Report.Debug (64, "ANONYMOUS DELEGATE", this, am, ec.ContainerType, type,
+				      ec, ec.capture_context, loc);
 
 			//
 			// Now emit the delegate creation.
 			//
-			if ((am.method.ModFlags & Modifiers.STATIC) == 0)
-				delegate_instance_expression = new AnonymousInstance (am);
-			
+			if ((am.Method.ModFlags & Modifiers.STATIC) == 0) {
+				delegate_instance_expression = am.RootScope.GetScopeInitializer (ec);
+				Report.Debug (64, "ANONYMOUS DELEGATE #0", this,
+					      delegate_instance_expression);
+
+				if (delegate_instance_expression == null)
+					throw new InternalErrorException ();
+			}
+
 			Expression ml = Expression.MemberLookup (ec.ContainerType, type, ".ctor", loc);
 			constructor_method = ((MethodGroupExpr) ml).Methods [0];
-			delegate_method = am.GetMethodBuilder ();
+			delegate_method = am.GetMethodBuilder (ec);
+			Report.Debug (64, "ANONYMOUS DELEGATE #1", constructor_method, delegate_method,
+				      delegate_method.GetType (), delegate_instance_expression);
 			base.Emit (ec);
 		}
-
-		class AnonymousInstance : Expression {
-			AnonymousMethod am;
-			
-			public AnonymousInstance (AnonymousMethod am)
-			{
-				this.am = am;
-				eclass = ExprClass.Value;
-			}
-
-			public override Expression DoResolve (EmitContext ec)
-			{
-				return this;
-			}
-			
-			public override void Emit (EmitContext ec)
-			{
-				am.aec.EmitMethodHostInstance (ec, am);
-			}
-		}
 	}
 
-	class CapturedParameter {
-		public Type Type;
-		public FieldBuilder FieldBuilder;
-		public int Idx;
-
-		public CapturedParameter (Type type, int idx)
-		{
-			Type = type;
-			Idx = idx;
-		}
-	}
-
 	//
 	// Here we cluster all the variables captured on a given scope, we also
 	// keep some extra information that might be required on each scope.
 	//
-	public class ScopeInfo {
-		public CaptureContext CaptureContext;
+	public class ScopeInfo : ScopeInfoBase {
 		public ScopeInfo ParentScope;
 		public Block ScopeBlock;
-		public bool NeedThis = false;
-		public bool HostsParameters = false;
 		
 		// For tracking the number of scopes created.
 		public int id;
 		static int count;
-		bool inited = false;
 		
 		ArrayList locals = new ArrayList ();
 		ArrayList children = new ArrayList ();
@@ -643,40 +1227,59 @@
 		//
 		// The types and fields generated
 		//
-		public TypeBuilder ScopeTypeBuilder;
-		public Type ScopeType;
-		public ConstructorInfo ScopeConstructor;
-		public FieldBuilder THIS;
-		public FieldBuilder ParentLink;
+		public readonly Location loc;
 
-		//
-		// Points to the object of type `ScopeTypeBuilder' that
-		// holds the data for the scope
-		//
-		LocalBuilder scope_instance;
-		
-		public ScopeInfo (CaptureContext cc, Block b)
+		public ScopeInfo (CaptureContext cc, Block block)
+			: base (cc.Host.RootScope, cc.Host.GenericMethod,
+				Modifiers.PUBLIC, cc.loc)
 		{
 			CaptureContext = cc;
-			ScopeBlock = b;
+			ScopeBlock = block;
+			loc = cc.loc;
 			id = count++;
 
+			Report.Debug (64, "NEW SCOPE", this);
+
 			cc.RegisterCaptureContext ();
+
+#if FIXME
+			if (!Define ())
+				throw new InternalErrorException ();
+			if (DefineType () == null)
+				throw new InternalErrorException ();
+#endif
 		}
 
-		public void AddLocal (LocalInfo li)
+		public ScopeInfo (CaptureContext cc, ToplevelBlock toplevel, TypeContainer parent,
+				  GenericMethod generic)
+			: base (parent, generic, 0, toplevel.StartLocation)
 		{
-			if (locals.Contains (li))
-				return;
+			CaptureContext = cc;
+			ScopeBlock = toplevel;
+			loc = cc.loc;
+			id = count++;
 
-			locals.Add (li);
-}
-	
-		public bool IsCaptured (LocalInfo li)
+			Report.Debug (64, "NEW ROOT SCOPE", this);
+
+			cc.RegisterCaptureContext ();
+		}
+
+		public override AnonymousMethodHost Host {
+			get { return CaptureContext.Host.RootScope; }
+		}
+
+		public Variable AddLocal (LocalInfo local)
 		{
-			return locals.Contains (li);
+			CapturedLocal cl = new CapturedLocal (this, local);
+			locals.Add (cl);
+			return cl;
 		}
-		
+
+		public Variable AddParameter (Parameter par, int idx)
+		{
+			return new CapturedParameter (this, par, idx);
+		}
+
 		internal void AddChild (ScopeInfo si)
 		{
 			if (children.Contains (si))
@@ -703,7 +1306,7 @@
 					children.Remove (child);
 				}
 			}
-		} 
+		}
 
 		static int indent = 0;
 
@@ -719,8 +1322,6 @@
 			Pad ();
 			Console.WriteLine ("START");
 			indent++;
-			Pad ();
-			Console.WriteLine ("NeedThis=" + NeedThis);
 			foreach (LocalInfo li in locals){
 				Pad ();
 				Console.WriteLine ("var {0}", MakeFieldName (li.Name));
@@ -733,168 +1334,18 @@
 			Console.WriteLine ("END");
 		}
 
-		private string MakeFieldName (string local_name)
+		protected string MakeFieldName (string local_name)
 		{
 			return "<" + id + ":" + local_name + ">";
 		}
 
-		public void EmitScopeType (EmitContext ec)
-		{
-			// EmitDebug ();
+		bool resolved;
 
-			if (ScopeTypeBuilder != null)
-				return;
-			
-			Type container;
-			if (ec.TypeContainer.CurrentType != null)
-				container = ec.TypeContainer.CurrentType;
-			else
-				container = ec.TypeContainer.TypeBuilder;
-
-			CaptureContext.Host.CreateScopeType (ec, this);
-			
-			if (NeedThis)
-				THIS = ScopeTypeBuilder.DefineField ("<>THIS", container, FieldAttributes.Assembly);
-
-			if (ParentScope != null){
-				if (ParentScope.ScopeTypeBuilder == null){
-					throw new Exception (String.Format ("My parent has not been initialized {0} and {1}", ParentScope, this));
-				}
-
-				if (ParentScope.ScopeTypeBuilder != ScopeTypeBuilder)
-					ParentLink = ScopeTypeBuilder.DefineField (
-						"<>parent", ParentScope.ScopeType, FieldAttributes.Assembly);
-			}
-			
-			if (NeedThis && ParentScope != null)
-				throw new Exception ("I was not expecting THIS && having a parent");
-
-			foreach (LocalInfo info in locals)
-				info.FieldBuilder = ScopeTypeBuilder.DefineField (
-					MakeFieldName (info.Name), info.VariableType, FieldAttributes.Assembly);
-
-			if (HostsParameters){
-				Hashtable captured_parameters = CaptureContext.captured_parameters;
-				
-				foreach (DictionaryEntry de in captured_parameters){
-					string name = (string) de.Key;
-					CapturedParameter cp = (CapturedParameter) de.Value;
-					FieldBuilder fb;
-					
-					fb = ScopeTypeBuilder.DefineField ("<p:" + name + ">", cp.Type, FieldAttributes.Assembly);
-					cp.FieldBuilder = fb;
-				}
-			}
-
-			foreach (ScopeInfo si in children){
-				si.EmitScopeType (ec);
-			}
-		}
-
-		public void CloseTypes ()
+		protected override ScopeInitializerBase CreateScopeInitializer ()
 		{
-			RootContext.RegisterCompilerGeneratedType (ScopeTypeBuilder);
-			foreach (ScopeInfo si in children)
-				si.CloseTypes ();
+			return new ScopeInitializer (this);
 		}
 
-		//
-		// Emits the initialization code for the scope
-		//
-		public void EmitInitScope (EmitContext ec)
-		{
-			ILGenerator ig = ec.ig;
-
-			if (inited)
-				return;
-
-			if (ScopeConstructor == null)
-				throw new Exception ("ScopeConstructor is null for" + this.ToString ());
-			
-			if (!CaptureContext.Host.IsIterator) {
-				scope_instance = ig.DeclareLocal (ScopeType);
-				ig.Emit (OpCodes.Newobj, ScopeConstructor);
-				ig.Emit (OpCodes.Stloc, scope_instance);
-			}
-
-			if (THIS != null){
-				if (CaptureContext.Host.IsIterator) {
-					ig.Emit (OpCodes.Ldarg_0);
-					ig.Emit (OpCodes.Ldarg_1);
-				} else {
-					ig.Emit (OpCodes.Ldloc, scope_instance);
-					ig.Emit (OpCodes.Ldarg_0);
-				}
-				ig.Emit (OpCodes.Stfld, THIS);
-			}
-
-			//
-			// Copy the parameter values, if any
-			//
-			int extra = ec.IsStatic ? 0 : 1;
-			if (CaptureContext.Host.IsIterator)
-				extra++;
-			if (HostsParameters){
-				Hashtable captured_parameters = CaptureContext.captured_parameters;
-				
-				foreach (DictionaryEntry de in captured_parameters){
-					CapturedParameter cp = (CapturedParameter) de.Value;
-
-					EmitScopeInstance (ig);
-					ParameterReference.EmitLdArg (ig, cp.Idx + extra);
-					ig.Emit (OpCodes.Stfld, cp.FieldBuilder);
-				}
-			}
-
-			if (ParentScope != null){
-				if (!ParentScope.inited)
-					ParentScope.EmitInitScope (ec);
-
-				if (ParentScope.ScopeTypeBuilder != ScopeTypeBuilder) {
-					//
-					// Only emit initialization in our capturecontext world
-					//
-					if (ParentScope.CaptureContext == CaptureContext){
-						EmitScopeInstance (ig);
-						ParentScope.EmitScopeInstance (ig);
-						ig.Emit (OpCodes.Stfld, ParentLink);
-					} else {
-						EmitScopeInstance (ig);
-						ig.Emit (OpCodes.Ldarg_0);
-						ig.Emit (OpCodes.Stfld, ParentLink);
-					}
-				}
-			}
-			inited = true;
-		}
-
-		public void EmitScopeInstance (ILGenerator ig)
-		{
-			if (CaptureContext.Host.IsIterator)
-				ig.Emit (OpCodes.Ldarg_0);
-			else {
-				if (scope_instance == null){
-					//
-					// This is needed if someone overwrites the Emit method
-					// of Statement and manually calls Block.Emit without
-					// this snippet first:
-					// 
-					//   ec.EmitScopeInitFromBlock (The_Block);
-					//   The_Block.Emit (ec);
-					// 
-
-					Console.WriteLine (
-				        	"The scope_instance has not been emitted, this typically means\n" +
-						"that inside the compiler someone is calling Block.Emit without\n" +
-						"first calling EmitScopeInitFromBlock for the block.  See compiler" +
-						"source code for an explanation");
-					throw new Exception ("Internal compiler error");
-					
-				}
-				ig.Emit (OpCodes.Ldloc, scope_instance);
-			}
-		}
-
 		public static void CheckCycles (string msg, ScopeInfo s)
 		{
 			ArrayList l = new ArrayList ();
@@ -935,6 +1386,174 @@
 
 			return sb.ToString ();
 		}
+
+		protected class CapturedParameter : Variable {
+			public readonly ScopeInfo Scope;
+			public readonly Parameter Parameter;
+			public readonly Field Field;
+			public readonly int Idx;
+
+			public FieldExpr FieldInstance;
+
+			public CapturedParameter (ScopeInfo scope, Parameter par, int idx)
+			{
+				this.Scope = scope;
+				this.Parameter = par;
+				this.Idx = idx;
+				Field = scope.CaptureVariable (
+					"<p:" + par.Name + ">", par.ParameterType);
+			}
+
+			public override Type Type {
+				get { return Field.MemberType; }
+			}
+
+			public override bool HasInstance {
+				get { return true; }
+			}
+
+			public override bool NeedsTemporary {
+				get { return true; }
+			}
+
+			protected FieldInfo GetField (EmitContext ec)
+			{
+				if ((Scope.Host is IteratorHost) ||
+				    (ec.capture_context != Scope.CaptureContext))
+					return Field.FieldBuilder;
+				else
+					return FieldInstance.FieldInfo;
+			}
+
+			public override void EmitInstance (EmitContext ec)
+			{
+				ec.capture_context.EmitParameterInstance (ec, Parameter);
+			}
+
+			public override void Emit (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldfld, GetField (ec));
+			}
+
+			public override void EmitAssign (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Stfld, GetField (ec));
+			}
+
+			public override void EmitAddressOf (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldflda, GetField (ec));
+			}
+
+			public override string ToString ()
+			{
+				return String.Format ("{0} ({1})", GetType (), Field);
+			}
+		}
+
+		protected class CapturedLocal : Variable {
+			public readonly ScopeInfo Scope;
+			public readonly LocalInfo Local;
+			public readonly Field Field;
+
+			public FieldExpr FieldInstance;
+
+			public CapturedLocal (ScopeInfo scope, LocalInfo local)
+			{
+				this.Scope = scope;
+				this.Local = local;
+				Field = scope.CaptureVariable (
+					scope.MakeFieldName (local.Name), local.VariableType);
+			}
+
+			public override Type Type {
+				get { return Field.MemberType; }
+			}
+
+			public override bool HasInstance {
+				get { return true; }
+			}
+
+			public override bool NeedsTemporary {
+				get { return true; }
+			}
+
+			public override void EmitInstance (EmitContext ec)
+			{
+				ec.capture_context.EmitCapturedVariableInstance (
+					ec, Local.Block, ec.CurrentAnonymousMethod);
+			}
+
+			public override void Emit (EmitContext ec)
+			{
+				if (ec.capture_context == Scope.CaptureContext)
+					ec.ig.Emit (OpCodes.Ldfld, FieldInstance.FieldInfo);
+				else
+					ec.ig.Emit (OpCodes.Ldfld, Field.FieldBuilder);
+			}
+
+			public override void EmitAssign (EmitContext ec)
+			{
+				if (ec.capture_context == Scope.CaptureContext)
+					ec.ig.Emit (OpCodes.Stfld, FieldInstance.FieldInfo);
+				else
+					ec.ig.Emit (OpCodes.Stfld, Field.FieldBuilder);
+			}
+
+			public override void EmitAddressOf (EmitContext ec)
+			{
+				if (ec.capture_context == Scope.CaptureContext)
+					ec.ig.Emit (OpCodes.Ldflda, FieldInstance.FieldInfo);
+				else
+					ec.ig.Emit (OpCodes.Ldflda, Field.FieldBuilder);
+			}
+		}
+
+		protected class ScopeInitializer : ScopeInitializerBase
+		{
+			ScopeInfo scope;
+
+			public ScopeInitializer (ScopeInfo scope)
+				: base (scope)
+			{
+				this.scope = scope;
+			}
+
+			new public ScopeInfo Scope {
+				get { return scope; }
+			}
+
+			protected override bool DoResolveInternal (EmitContext ec)
+			{
+				Report.Debug (64, "RESOLVE SCOPE INITIALIZER", this, Scope,
+					      Scope.ParentScope, Scope.ScopeType, ec,
+					      ec.TypeContainer.Name, ec.DeclContainer,
+					      ec.DeclContainer.Name, ec.DeclContainer.IsGeneric);
+
+				foreach (CapturedLocal local in Scope.locals) {
+					FieldExpr fe = (FieldExpr) Expression.MemberLookup (
+						ec.ContainerType, type, local.Field.Name, loc);
+					Report.Debug (64, "RESOLVE SCOPE INITIALIZER #2", this, Scope,
+						      Scope, ec, ec.ContainerType, type,
+						      local.Field, local.Field.Name, loc, fe);
+					if (fe == null)
+						throw new InternalErrorException ();
+
+					fe.InstanceExpression = this;
+					local.FieldInstance = fe;
+				}
+
+				return base.DoResolveInternal (ec);
+			}
+
+			protected virtual void EmitParameterReference (EmitContext ec,
+								       CapturedParameter cp)
+			{
+				int extra = ec.IsStatic ? 0 : 1;
+				ParameterReference.EmitLdArg (ec.ig, cp.Idx + extra);
+			}
+
+		}
 	}
 
 	//
@@ -952,7 +1571,8 @@
 		//
 		// Points to the toplevel block that owns this CaptureContext
 		//
-		ToplevelBlock toplevel_owner;
+		public readonly ToplevelBlock ToplevelOwner;
+		public readonly IAnonymousContainer Host;
 
 		//
 		// All the scopes we capture
@@ -965,25 +1585,23 @@
 		ArrayList roots = new ArrayList ();
 		
 		bool have_captured_vars = false;
-		bool referenced_this = false;
 
 		//
 		// Captured fields
 		//
 		Hashtable captured_fields = new Hashtable ();
 		Hashtable captured_variables = new Hashtable ();
-		public Hashtable captured_parameters = new Hashtable ();
-		public AnonymousContainer Host;
-		
+		internal Hashtable captured_parameters = new Hashtable ();
+
 		public CaptureContext (ToplevelBlock toplevel_owner, Location loc,
-				       AnonymousContainer host)
+				       IAnonymousContainer host)
 		{
 			cc_id = count++;
-			this.toplevel_owner = toplevel_owner;
+			this.ToplevelOwner = toplevel_owner;
+			this.Host = host;
 			this.loc = loc;
 
-			if (host != null)
-				Host = host;
+			Report.Debug (64, "NEW CAPTURE CONTEXT", this, toplevel_owner, loc);
 		}
 
 		void DoPath (StringBuilder sb, CaptureContext cc)
@@ -995,17 +1613,6 @@
 			sb.Append (cc.cc_id.ToString ());
 		}
 
-		public void ReParent (ToplevelBlock new_toplevel, AnonymousContainer new_host)
-		{
-			toplevel_owner = new_toplevel;
-			Host = new_host;
-
-			for (CaptureContext cc = ParentCaptureContext; cc != null;
-			     cc = cc.ParentCaptureContext) {
-				cc.Host = new_host;
-			}
-		}
-		
 		public override string ToString ()
 		{
 			StringBuilder sb = new StringBuilder ();
@@ -1017,7 +1624,7 @@
 
 		public ToplevelBlock ParentToplevel {
 			get {
-				return toplevel_owner.Container;
+				return ToplevelOwner.Container;
 			}
 		}
 
